var DocumentationMenu;
(function (DocumentationMenu) {
    var NodeModel = /** @class */ (function () {
        function NodeModel(data) {
            var _this = this;
            this.isExpanded = ko.observable(false);
            this.description = ko.observable('');
            this.name = ko.observable('');
            this.nodes = ko.observable();
            if (data == null)
                throw "null data";
            this.description(data.description);
            this.name(data.name);
            this.nodeCssClass = ko.pureComputed(function () {
                return {
                    'tree-icon': true,
                    'minus-sign': _this.isExpanded() && _this.nodes().length > 0,
                    'plus-sign': !_this.isExpanded() && _this.nodes().length > 0,
                    //'square': this.nodes().length === 0,
                    'no-icon': _this.nodes().length === 0
                };
            });
            this.nodes(data.nodes.makeIterable().select(function (n) { return new NodeModel(n); }).toArray());
        }
        NodeModel.prototype.toggleVisibility = function () {
            this.isExpanded(!this.isExpanded());
        };
        ;
        return NodeModel;
    }());
    var TreeModel = /** @class */ (function () {
        function TreeModel(tree) {
            this.nodes = ko.observable();
            this.nodes(tree.nodes.makeIterable().select(function (n) { return new NodeModel(n); }).toArray());
        }
        return TreeModel;
    }());
    var PageModel = /** @class */ (function () {
        function PageModel(input) {
            this.tree = ko.observable();
            this.tree(new TreeModel(input.tree));
        }
        return PageModel;
    }());
    function Init(input) {
        var model = new PageModel(input);
        ko.applyBindings(model);
    }
    DocumentationMenu.Init = Init;
})(DocumentationMenu || (DocumentationMenu = {}));
var rubbish = {
    tree: {
        nodes: [
            {
                name: 'HDARS 1',
                description: 'hello dears',
                objectId: '',
                nodes: [
                    {
                        name: 'Child 1',
                        description: 'test description!',
                        objectId: '',
                        nodes: []
                    },
                    {
                        name: 'Child 2',
                        description: 'test description! asd',
                        objectId: '',
                        nodes: [
                            {
                                name: 'Child Child 1',
                                description: 'test description test description ',
                                objectId: '',
                                nodes: []
                            }
                        ]
                    }
                ]
            },
            {
                name: 'Hdars 2',
                description: 'for sirs, description of long for still rubbish',
                objectId: '',
                nodes: []
            },
            {
                name: 'Hdars 3',
                description: '',
                objectId: '',
                nodes: []
            }
        ]
    }
};
$(function () { return DocumentationMenu.Init(rubbish); });
//# sourceMappingURL=inedo_documentationmenu2.js.map